<?php

namespace App\Libraries;

use PDO;

class Database
{
    private static $options = array(
        PDO::ATTR_EMULATE_PREPARES => false, // Habilita el uso nativo de consultas preparadas
        PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION, // Lanzar una PDOException si ocurre algún error
    );
    private static $instance = null;
    private $connection;

    private function __construct()
    {
        $dsn = DATABASE['driver'] . ':host=' . DATABASE['host'] . ';dbname=' . DATABASE['database']
            . ';port=' . DATABASE['port'] . ';charset=' . DATABASE['charset'];
        try {
            $this->connection = new PDO($dsn, DATABASE['username'], DATABASE['password']);
        } catch (\PDOException $e) {
            die($e->getMessage());
        }
    }

    public static function connect()
    {
        if (!self::$instance) {
            $class = __CLASS__;
            self::$instance = new $class;
        }
        return self::$instance;
    }

    public function prepare($sql)
    {
        return $this->connection->prepare($query);
    }

    public function query($sql)
    {
        return $this->connection->query($query);
    }
}
